//test

#include <unistd.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <assert.h>

#include <netinet/in.h>

#include "fastopen_kernel_def.h"

static int test0()
{
	//syscall1(__NR_exit, 2);
	return 0;
}


static int test1()
{
	int s = socket(AF_INET, SOCK_STREAM, 0);
	assert(s >= 0);
	return syscall1(__NR_close, s);
}

static int test2()
{
	int ret = 0;
	ret |= syscall2(__NR_chmod, ".", 0777);
	ret |= syscall2(__NR_chmod, ".", 0755);
	ret |= (!syscall2(__NR_chmod, "/ababa", 0777));
	return ret;
}

static int test3()
{
	int s = open("tst-syscall.c", O_RDONLY);
	if (s < 0) return s;
	char buff[7] = {0};
	int ret = syscall3(__NR_read, s, buff, 6);
	assert(buff[6] == 0);
	assert(strcmp(buff, "//test") == 0);
	return !(ret == 6);
}

static int test4()
{
	int s = real_socket(AF_INET, SOCK_STREAM, 0);
	struct sockaddr_in addr = {
		.sin_family = AF_INET,
		.sin_port = htons(10000),
		.sin_addr = {
			.s_addr = INADDR_ANY
		}
	};
	assert(s > 0);
	assert(real_bind(s, &addr, sizeof(addr)) == 0);
	assert(real_close(s) == 0);
	return 0;
}

int main()
{
	if (!test0()) printf("passed 0\n");
	if (!test1()) printf("passed 1\n");
	if (!test2()) printf("passed 2\n");
	if (!test3()) printf("passed 3\n");
	if (!test4()) printf("passed 4\n");
}


